/* phost - displays important stuff from hptr queries */
/* Mark Kamichoff <kamicm@rpi.edu>                    */

#include<stdio.h>
#include<netdb.h>
#include<string.h>

#ifndef _VERSION_
#define _VERSION_ "unknown"
#endif

int main(int argc, char **argv)
{
	struct hostent *hptr, *hptr2;
	struct in_addr **pptr;
	char **aliases;
	struct sockaddr_in address;
	char str[INET6_ADDRSTRLEN];

	if(argc == 1)
	{
		printf("Syntax: %s <name/ip>\n",argv[0]);
		exit(1);
	}
	else if(argc > 2)
	{
		printf("Syntax: %s <name/ip>\n",argv[0]);
		exit(1);
	}
	else if((argc == 2) && (strcmp(argv[1],"--version") == 0))
	{
		printf("%s\n",_VERSION_);
		exit(1);
	}
	else
	{
		printf("phost %s\n",_VERSION_);
	}

	hptr = gethostbyname(argv[1]);

	if(hptr == NULL)
	{
		fprintf(stderr, "Resolver returner an error for %s\n",
			argv[1]);
		exit(1);
	}

	pptr = (struct in_addr **) hptr->h_addr_list;
	aliases = hptr->h_aliases;
	
	printf("h_name for %s returned %s\n", argv[1], hptr->h_name);

	printf("\nAliases for %s are as follows:\n", hptr->h_name);
	if(*aliases == NULL)
	{
		printf("\t(None)\n");
	}
	else
	{
		while(*aliases != NULL)
		{
			printf("\t%s\n", *aliases);
			aliases++;
		}
	}

	printf("\nIP addresses for %s are as follows:\n", hptr->h_name);
	while(*pptr != NULL)
	{
		printf("\t%s -> ", inet_ntop(hptr->h_addrtype,
			*pptr, str, sizeof(str)));
		hptr2 = gethostbyaddr(*pptr, sizeof(*pptr), AF_INET);
		if(hptr2 == NULL)
		{
			printf("(No PTR associated)\n");
		}
		else
			printf("%s\n", hptr2->h_name);
		pptr++;
	}

	exit(0);
}
